unit UGoal2DRaced;

interface

uses UGoal, UPlayer2D;

type TGoal2DRaced = class(TGoal)
  private
  protected
  public
    procedure ScoreGoal(player: TObject); override;
    procedure Draw(player: TObject); override;
  end;


implementation


procedure TGoal2dRaced.ScoreGoal(player: TObject);
var
  p: TPlayer2D;
begin
  inherited;
  p:= TPlayer2D(player);
  if p.Dead then exit;
  // Add Euclidean distance, using "Owner.Size" as the unit:
  Score:= Sqrt(Sqr(p.PosX-p.OldPosX) + Sqr(p.PosY-p.OldPosY)) / p.Size;
end;

procedure TGoal2dRaced.Draw(player: TObject);
begin
  // Avoid a warning about Draw being an abstract method.
end;

end.
